<%
  'Secure Application Shell 1.0
  
  'Version History
  ' 1.0.1 - 30/09/01 - Initial Prototyping
  '                  - DB Open/Close, MD5, Session, Error, Init/Final Functional & Tested
  ' 1.0.2 - 02/09/01 - Added basic group list generation & checking
  '                  - Added skeletons for all other functions
  '                  - Added 'enabled' flag for user accounts
  ' 1.0.3 - 05/10/01 - Administration functions
  '                  - Included htmldictionary class inline
  ' 1.0.4 - 15/10/01 - Dictionary handling

  'TODO
  ' 1) Add enurmeration class (ie movefirst, movenext, movelast, eof)
  '     - Input from specified users group list
  '     - Input from specified users dictionary
  '     - Input from specified groups membership list


  '------------------------------------------------------------------
  ' Global Constants & Variables
  '------------------------------------------------------------------

  SecShell_IsInitialised=FALSE
  SecShell_IsDBOpen=FALSE
  SecShell_CommandSeparator="^"
  SecShell_ValueSeparator="~"
  SecShell_ErrorCode=0
  SecShell_DSN="DSN=secshell_02"
  SecShell_Salt="mnh37hSGFdkjygkhD8Tfhbfk85hbsNGHfkjew68uFGHvcp6aluijJH8705vckjvy"

  SecShell_SessionData_SessionID=""
  SecShell_SessionData_Username=""
  SecShell_SessionData_Dictionary=""
  SecShell_SessionData_GroupList=""

  set SecShell_oDictionary=new htmldictionary
  
  dim SecShell_DBCon
  dim SecShell_Error(50)

  '------------------------------------------------------------------
  ' Database Access Code - User Customisable
  '------------------------------------------------------------------

  Public Sub SecShell_DB_Open()
   if SecShell_IsDBOpen<>FALSE then
    SecShell_RaiseError(5)
   else
    set SecShell_DBCon=Server.CreateObject("ADODB.Connection")
    SecShell_DBCon.Open SecShell_DSN
    SecShell_IsDBOpen=TRUE
   end if   
  End Sub

  Public Sub SecShell_DB_Close()
   if SecShell_IsDBOpen<>TRUE then
    SecShell_RaiseError(4)
   else
    SecShell_DBCon.Close
    SecShell_IsDBOpen=FALSE
    set SecShell_DBCon=nothing
   end if
  End Sub


  '------------------------------------------------------------------
  ' Initialisation / Finalisation
  '------------------------------------------------------------------

  Public Sub SecShell_Initialise()
   if SecShell_IsInitialised<>TRUE then
    SecShell_IsInitialised=TRUE
    SecShell_SessionData_SessionID=Request.Form("SecShell_SessionData_SessionID")
    SecShell_SessionData_Username=Request.Form("SecShell_SessionData_Username")
    SecShell_SessionData_Dictionary=Request.Form("SecShell_SessionData_Dictionary")
    SecShell_SessionData_GroupList=Request.Form("SecShell_SessionData_GroupList")
    SecShell_oDictionary.Initialise
    SecShell_oDictionary.SetDictionary(SecShell_SessionData_Dictionary)
    'Write the hidden security form for later use
    %>
      <form name="SecShell" method="post" action="">
       <input type="hidden" name="SecShell_SessionData_SessionID" value="">
       <input type="hidden" name="SecShell_SessionData_Username" value="">
       <input type="hidden" name="SecShell_SessionData_Dictionary" value="">
       <input type="hidden" name="SecShell_SessionData_GroupList" value="">
      </form>
    <%
   else
    SecShell_RaiseError(3)
   end if
  End Sub

  Public Sub SecShell_Finalise()
   if SecShell_IsInitialised<>TRUE then
    SecShell_RaiseError(2)
   else
    if SecShell_IsDBOpen<>FALSE then
     SecShell_DB_Close()
    end if
    'Persist the current session back to the browser
    SecShell_SessionData_Dictionary=SecShell_oDictionary.GetDictionary
    SecShell_SessionData_SessionID=SecShell_Encryption_GetHash(SecShell_SessionData_Username+ _
                                   SecShell_SessionData_Dictionary+ _
                                   SecShell_SessionData_GroupList+ _
                                   SecShell_Salt) 
    %>
      <script language="javascript">
       document.SecShell.SecShell_SessionData_SessionID.value='<%=SecShell_SessionData_SessionID%>';
       document.SecShell.SecShell_SessionData_Username.value='<%=SecShell_SessionData_Username%>';
       document.SecShell.SecShell_SessionData_Dictionary.value='<%=SecShell_SessionData_Dictionary%>';
       document.SecShell.SecShell_SessionData_GroupList.value='<%=SecShell_SessionData_GroupList%>';
      </script>
    <%
   end if
  End Sub


  '------------------------------------------------------------------
  ' Error Handling
  '------------------------------------------------------------------

  Public Sub SecShell_InitHandler
   SecShell_Error(1)="SecurityShell could not intialise"
   SecShell_Error(2)="Attempt to call function failed because the SecurityShell has not been initialised."
   SecShell_Error(3)="SecurityShell is already initialised"
   SecShell_Error(4)="Unable to close database as it is currently not open"
   SecShell_Error(5)="Unable to open database as it is already open"
   SecShell_Error(6)="Null usernames/passwords are not permitted"
   SecShell_Error(7)="Invalid username/password"
   SecShell_Error(8)="Unable to read attribute of current session as none exists"
   SecShell_Error(9)="User does not exist in any groups"
   SecShell_Error(10)="You must be a member of the acadmin group to access user account management functions"
   SecShell_Error(11)="You must login before attempting to access user account management functions"
   SecShell_Error(12)="You can not set your password unless you are already logged in"
   SecShell_Error(13)="You can not access dictionary functions unless you are already logged in"
  End Sub

  Public Sub SecShell_RaiseError(erc)
   SecShell_ErrorCode=erc
  End Sub

  Public Function SecShell_ReadError()
   dim outp
   if SecShell_ErrorCode<>0 then
    outp=SecShell_Error(SecShell_ErrorCode)
    SecShell_ErrorCode=0
   else 
    outp="None"
   end if
   SecShell_ReadError=outp
  End Function


  '------------------------------------------------------------------
  ' Encryption Code (Wrapper for FlexeprintSec.Encryption COMponent)
  '------------------------------------------------------------------

  Public Function SecShell_Encryption_GetHash(inp)
   dim outp
   dim encrypt
   set encrypt=Server.CreateObject("FlexeprintSec.Encryption")
   encrypt.MD5_Initialize
   outp=encrypt.MD5_Digest(cstr(inp))
   set encrypt=nothing
   SecShell_Encryption_GetHash=outp
  End Function


  '------------------------------------------------------------------
  ' Login & General Session Handling
  '------------------------------------------------------------------

  Public Function SecShell_Session_Check
   dim outp
   outp=FALSE
   if SecShell_SessionData_SessionID<>"" then
    'recalculate the SessionID given the other three fields + salt
    if SecShell_Encryption_GetHash(SecShell_SessionData_Username+ _
                                   SecShell_SessionData_Dictionary+ _
                                   SecShell_SessionData_GroupList+ _
                                   SecShell_Salt) _
                                     =SecShell_SessionData_SessionID then
     outp=TRUE
    end if
   end if
   SecShell_Session_Check=outp
  End Function

  Public Function SecShell_Session_Login(username,password)
   if username<>"" AND password<>"" then
    'Check the database is open
    if SecShell_IsDBOpen<>TRUE then
     SecShell_DB_Open
    end if
    'Hash password so that we are comparing encrypted versions
    password=SecShell_Encryption_GetHash(username+password)
    'Create a recordset object and query for a matching user/pasw pair
    dim result
    set result=Server.CreateObject("ADODB.Recordset")
    result.open "SELECT * FROM users WHERE username='"+username+"' AND password='"+password+"' AND enabled='Y';", SecShell_DBCon
    if result.eof then
     SecShell_RaiseError(7)
    else
     'Create session for user
     SecShell_SessionData_Username=username
     SecShell_SessionData_Dictionary=result("dictionary")
     SecShell_SessionData_GroupList=SecShell_Groups_ReadCurrentUser
     SecShell_SessionData_SessionID=SecShell_Encryption_GetHash(SecShell_SessionData_Username+ _
                                                                SecShell_SessionData_Dictionary+ _
                                                                SecShell_SessionData_GroupList+ _
                                                                SecShell_Salt) 
     SecShell_oDictionary.Initialise
     SecShell_oDictionary.SetDictionary(SecShell_SessionData_Dictionary)
    end if
    result.close
    set result=nothing
   else
    SecShell_RaiseError(6)
   end if
  End Function

  Public Function SecShell_Session_GetUserName
   dim outp
   outp="ERROR"
   if SecShell_Session_Check=TRUE then
    outp=SecShell_SessionData_Username
   else
    SecShell_RaiseError(8)
   end if
   SecShell_Session_GetUserName=outp
  End Function

  Public Sub SecShell_Session_Logout
   SecShell_SessionData_SessionID=""
   SecShell_SessionData_Username=""
   SecShell_SessionData_Dictionary=""
   SecShell_SessionData_GroupList=""
  End Sub


  '------------------------------------------------------------------
  ' Dictionary Handling
  '------------------------------------------------------------------

  Public Sub SecShell_Dictionary_Clear
   if SecShell_Session_Check=TRUE then
    SecShell_oDictionary.Initialise
   else
    SecShell_RaiseError(13)
   end if
  End Sub

  Public Sub SecShell_Dictionary_AddItem(item,value)
   if SecShell_Session_Check=TRUE then
    SecShell_oDictionary.AddItem item, value
   else
    SecShell_RaiseError(13)
   end if
  End Sub

  Public Sub SecShell_Dictionary_SetItem(item,value)
   if SecShell_Session_Check=TRUE then
    SecShell_oDictionary.SetItem item, value
   else
    SecShell_RaiseError(13)
   end if
  End Sub

  Public Sub SecShell_Dictionary_EraseItem(item)
   if SecShell_Session_Check=TRUE then
    SecShell_oDictionary.RemoveItem(item)
   else
    SecShell_RaiseError(13)
   end if
  End Sub

  Public Function SecShell_Dictionary_GetItem(item)
   dim outp
   outp=""
   if SecShell_Session_Check=TRUE then
    outp=SecShell_oDictionary.GetItem(item)
   else
    SecShell_RaiseError(13)
   end if
   SecShell_Dictionary_GetItem=outp
  End Function

  Public Sub SecShell_Dictionary_Save
   if SecShell_Session_Check=TRUE then
    if SecShell_IsDBOpen<>TRUE then
     SecShell_DB_Open
    end if
    SecShell_SessionData_Dictionary=SecShell_oDictionary.GetDictionary
    sql="UPDATE users SET dictionary='"+SecShell_SessionData_Dictionary+"' WHERE username='"+SecShell_SessionData_Username+"';"
    SecShell_DBCon.Execute sql
   else
    SecShell_RaiseError(13)
   end if
  End Sub


  '------------------------------------------------------------------
  ' Group List Handling
  '------------------------------------------------------------------

  Public Function SecShell_Groups_ReadCurrentUser
    dim outp
    outp="^"
    dim groupr
    set groupr=Server.CreateObject("ADODB.Recordset")
    groupr.open "SELECT * FROM group_memberships WHERE username='"+SecShell_SessionData_Username+"';", SecShell_DBCon
    if groupr.eof then
     SecShell_RaiseError(9)
     outp="ERR"
    else
     groupr.movefirst
     do while not groupr.eof
      outp=outp+groupr("groupm")+SecShell_CommandSeparator
      groupr.movenext
     loop
    end if
    groupr.close
    set groupr=nothing
    SecShell_Groups_ReadCurrentUser=outp
  End Function


  Public Function SecShell_Groups_IsInGroup(group)
   dim outp
   outp=FALSE
   if SecShell_Session_Check=TRUE then
    if instr(SecShell_SessionData_GroupList,SecShell_CommandSeparator+group+SecShell_CommandSeparator)>0 then outp=true
   end if
   SecShell_Groups_IsInGroup=outp
  End Function


  '------------------------------------------------------------------
  ' User Management
  '------------------------------------------------------------------

  Public Sub SecShell_User_Add(username,password,fullname)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     password=SecShell_Encryption_GetHash(username+password)
     sql="INSERT INTO users (username, password, fullname, dictionary, enabled) VALUES ("
     sql=sql+"'"+username+"',"  
     sql=sql+"'"+password+"',"     
     sql=sql+"'"+fullname+"'," 
     sql=sql+"'"+SecShell_ValueSeparator+"','Y');"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_Erase(username)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="DELETE * FROM users WHERE username='"+username+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_PWD(username,password)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     password=SecShell_Encryption_GetHash(username+password)
     sql="UPDATE users SET password='"+password+"' WHERE username='"+username+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_AddToGroup(username,group)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
'TODO
'Check to see if group exists before inserting membership record
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="INSERT INTO group_memberships (username, groupm) VALUES ("
     sql=sql+"'"+username+"',"     
     sql=sql+"'"+group+"');"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_RemoveFromGroup(username,group)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="DELETE * FROM group_memberships WHERE username='"+username+"' AND groupm='"+group+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_Enable(username)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="UPDATE users SET enabled='Y' WHERE username='"+username+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_User_Disable(username)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="UPDATE users SET enabled='N' WHERE username='"+username+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_Group_Add(name,description)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="INSERT INTO groups (group_name, group_description) VALUES ("
     sql=sql+"'"+name+"',"  
     sql=sql+"'"+description+"');"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub

  Public Sub SecShell_Group_Remove(name)
   if SecShell_Session_Check=TRUE then
    if SecShell_Groups_IsInGroup("acadmin") then
     if SecShell_IsDBOpen<>TRUE then
      SecShell_DB_Open
     end if
     sql="DELETE * FROM group_memberships WHERE groupm='"+name+"';"
     SecShell_DBCon.Execute sql
     sql="DELETE * FROM groups WHERE group_name='"+name+"';"
     SecShell_DBCon.Execute sql
    else
     SecShell_RaiseError(10)
    end if
   else
    SecShell_RaiseError(11)
   end if
  End Sub


  '--------------------------------------------------------------
  ' Support (Classes etc)
  '--------------------------------------------------------------


  'Dictionary Class
  'Version 1.0
  
  'Name-value pair dictionary class enconding safe for transport in a HTML FORM field.

  'History
  'v1.0.1 - 05/09/01 - Initial prototype
  '                  - Init, Final, Set, Get, Add, Read, Write, Erase
  '                  - Check input names/values for sep chars
  

  Class htmldictionary

  ' Global variables, Initialisation, Finalisation
 
  dim thedictionary
  dim itemsep
  dim ivsep

  Public Sub Initialise()
   itemsep="~"
   ivsep="^"
   thedictionary=itemsep
  End Sub
  
  Public Sub Finalise()
   thedictionary=""
  End Sub

  ' Public Interface

  Public Sub SetDictionary(thedict)
   if len(cstr(thedict))>0 then
    thedictionary=cstr(thedict)
   else
    thedictionary=itemsep
   end if
  End Sub

  Public Function GetDictionary()
   dim outp
   if len(thedictionary)>1 then
    outp=thedictionary
   else
    outp="~"
   end if
   GetDictionary=outp
  End Function

  Public Function AddItem(itemname,itemvalue)
   if instr(itemname,itemsep)>0 or instr(itemname,ivsep)>0 or instr(itemvalue,itemsep)>0 or instr(itemvalue,ivsep)>0 then
   else
    thedictionary=thedictionary+cstr(itemname)+ivsep+cstr(itemvalue)+itemsep
   end if
  End Function

  Public Function SetItem(itemname,itemvalue)
   if instr(itemvalue,itemsep)>0 or instr(itemvalue,ivsep)>0 then
   else
    dim rpart
    dim lpart
    if instr(thedictionary,cstr(itemname))>0 then
     rpart=right(thedictionary,(len(thedictionary)-(instr(thedictionary,cstr(itemname))+len(itemname))))
     rpart=right(rpart,len(rpart)-instr(rpart,itemsep)+1)
     lpart=left(thedictionary,instr(thedictionary,cstr(itemname))+1)
     thedictionary=lpart+cstr(itemvalue)+rpart
    end if
   end if
  End Function

  Public Function GetItem(itemname)
   dim outp
   dim temp
   outp=""
   if instr(thedictionary,cstr(itemname))>0 then
    temp=right(thedictionary,(len(thedictionary)-(instr(thedictionary,cstr(itemname))+len(itemname))))
    temp=left(temp,instr(temp,itemsep)-1)
    outp=temp
   else
    outp="ERR"
   end if
   GetItem=outp
  End Function

  Public Sub RemoveItem(itemname)
   dim rpart
   dim lpart
   if instr(thedictionary,cstr(itemname))>0 then
    rpart=right(thedictionary,(len(thedictionary)-(instr(thedictionary,cstr(itemname))+len(itemname))))
    rpart=right(rpart,len(rpart)-instr(rpart,itemsep))
    lpart=left(thedictionary,instr(thedictionary,cstr(itemname))-1)
    thedictionary=lpart+rpart
   end if
   if thedictionary="" then thedictionary=thedictionary+itemsep
  End Sub

  ' Special Options

  Public Sub SetItemSeparator(i)
   itemsep=cstr(i)
  End Sub

  Public Sub SetValueSeparator(i)
   ivsep=cstr(i)
  End Sub

  End Class


%>